# phpSmug Documentation

## Overview

phpSmug is a simple object orientated wrapper for the new SmugMug API v2, written in PHP.

The intention of this class is to allow PHP application developers quick and easy interaction with the SmugMug API, without having to worry about the finer details of the API.

Not already a SmugMug user? Here, have a $5 discount off your first year on me by [registering](https://secure.smugmug.com/signup.mg?Coupon=2ZxFXMC19qOxU) using this code: **[2ZxFXMC19qOxU](https://secure.smugmug.com/signup.mg?Coupon=2ZxFXMC19qOxU)**

The development of phpSmug takes place in my free time. If you find phpSmug useful and found it has saved you a lot of time, I’d really appreciate it if you bought me a coffee or two.

[![Buy me a Coffee](https://www.buymeacoffee.com/assets/img/custom_images/orange_img.png)](https://www.buymeacoffee.com/lildude)

---

- [Requirements & Installation](installation.md)
- [Usage](usage.md)
  - [Basic Usage](usage.md#basic-usage)
  - [More In-depth Usage Details](usage.md#more-in-depth-usage-details)
    - [Instantiating the Client](usage.md#instantiating-the-client)
    - [Interacting with the SmugMug API](usage.md#interacting-with-the-smugmug-api)
      - [GETting Information](usage.md#getting-information)
      - [Making Changes](usage.md#making-changes)
      - [Probing the API](usage.md#probing-the-api)
- [Authentication](authentication.md)
- [Display Private Images](private-images.md)
- [Uploading & Replacing Images](uploading.md)
  - [Upload a Local Image](uploading.md#upload-a-local-image)
  - [Upload an Image from a URL](uploading.md#upload-an-image-from-a-url)
  - [Replacing Images](uploading.md#replacing-images)
- [Other Notes](other.md)
  - [Caching API Responses](other.md#caching-api-responses)
  - [Access SmugMug via a Proxy](other.md#)
  - [Examples](other.md#examples)
  - [Reporting Issues](other.md#reporting-issues)
  - [Getting Help](other#getting-help)
  - [Contributing](other#contributing)

You can also view all of the documentation in this repository at <http://phpsmug.com/>.
